package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.ui.TooltipMakerAPI;

import java.awt.*;

public class chm_sfcfuel extends BaseHullMod {

    public static final float BURN_BONUS = 1;
    public static float FUEL_PERCENT = 10;

    public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
        stats.getMaxBurnLevel().modifyFlat(id, BURN_BONUS);
        stats.getFuelUseMod().modifyPercent(id, -FUEL_PERCENT);
    }

    public String getDescriptionParam(int index, HullSize hullSize) {
        if (index == 0) return "" + (int) BURN_BONUS;
        if (index == 1) return "10%";
        return null;
    }

    private final Color color = new Color(222, 109, 158, 255);
    @Override
    public void advanceInCombat(ShipAPI ship, float amount) {
        ship.getEngineController().fadeToOtherColor(this, color, null, 1f, 0.4f);
        ship.getEngineController().extendFlame(this, 0.25f, 0.25f, 0.25f);
    }
    @Override
    public Color getNameColor() {
        return new Color(160,0,95,255);
    }
    @Override
    public void addPostDescriptionSection(final TooltipMakerAPI tooltip, final ShipAPI.HullSize hullSize, final ShipAPI ship, final float width, final boolean isForModSpec) {
        final Color flavor = new Color(110,110,110,255);
        float padList = 6f;
        float padSig = 1f;
        tooltip.addPara("%s", padList, flavor, new String[] { "\"When you're looking for the best fuel in town, Sindrian Fuel has the best around!\"" });
        tooltip.addPara("%s", padSig, flavor, new String[] { "         \u2014 Sindrian Fuel Company Jingle" });
    }
}