package data.scripts;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.*;
import com.fs.starfarer.api.characters.FullName;
import com.fs.starfarer.api.characters.FullName.Gender;
import com.fs.starfarer.api.characters.ImportantPeopleAPI;
import com.fs.starfarer.api.characters.PersonAPI;
import com.fs.starfarer.api.BaseModPlugin;
import com.fs.starfarer.api.impl.campaign.fleets.FleetFactoryV3;
import com.fs.starfarer.api.impl.campaign.fleets.FleetParamsV3;
import com.fs.starfarer.api.impl.campaign.ids.*;
import com.fs.starfarer.api.campaign.econ.MarketAPI;
import com.fs.starfarer.api.impl.campaign.skills.OfficerTraining;
import com.fs.starfarer.rpg.Person;
import sound.F;

public class sfc_ModPlugin extends BaseModPlugin {

   //public static boolean isDE = Global.getSettings().getModManager().isModEnabled("Diktat Enhancement");

    public static String sfckween = "sfckween"; //glorious science
    public static String sfcruni = "sfcruni"; //looks familiar
    public static String sfcmann = "sfcmann"; //2nd coolest old guy in the Sindrian Fuel Company
    public static String sfcruy = "sfcruy"; //envious of the lion's guard
    public static String sfcdunn = "sfcdunn"; //loves "surprise internship" camps
    public static String sfcfleures = "sfcfleures"; //brightest flower
    public static String dedustier = "dedustier"; //preacher for the Lion and DE integration
    public static String nftpononzi = "nftpononzi"; //does he have an ape?

    private void addGrandFuelFleet() {
        SectorAPI sector = Global.getSector();
        StarSystemAPI system = sector.getStarSystem("Askonia");
        SectorEntityToken volturn = system.getEntityById("volturn");
        // SFC Grand Fuel Fleet
        FleetParamsV3 params = new FleetParamsV3(
                volturn.getMarket(), // add a source(has to be from a MarketAPI)
                null, // loc in hyper; don't need if have market
                "sindrian_diktat",
                2f, // quality override route.getQualityOverride()
                FleetTypes.TASK_FORCE,
                800f, // combatPts(minimal so special ships can be added)
                0f, // freighterPts
                0f, // tankerPts
                0f, // transportPts
                0f, // linerPts
                0f, // utilityPts
                0f// qualityMod
        );
        params.officerNumberMult = 2f;
        params.officerLevelBonus = 4;
        params.officerNumberBonus = 4;
        params.officerLevelLimit = Global.getSettings().getInt("officerMaxLevel") + (int) OfficerTraining.MAX_LEVEL_BONUS;
        params.modeOverride = FactionAPI.ShipPickMode.ALL;
        params.averageSMods = 2;
        params.flagshipVariantId = "sfciapetus_Mixed";
        CampaignFleetAPI fleet = FleetFactoryV3.createFleet(params);
        if (fleet == null || fleet.isEmpty()) return;
        fleet.setFaction("sindrian_diktat", true);
        fleet.getFlagship().setShipName("SFS Supreme Manager");
        fleet.getFlagship().setId("sfciapetus_Mixed");
        fleet.getFleetData().addFleetMember("sfcprometheus_barrage");
        fleet.getFleetData().addFleetMember("sfcprometheus_barrage");
        fleet.getFleetData().addFleetMember("sfcepimetheus_Pulser");
        fleet.getFleetData().addFleetMember("sfcskyrend_Barrage");
        fleet.getFleetData().addFleetMember("sfcskyrend_Barrage");
        fleet.getFleetData().addFleetMember("sfcarke_Supporter");
        fleet.getFleetData().addFleetMember("sfcarke_Supporter");
        fleet.getFleetData().addFleetMember("sfcarke_Suppression");
/*        fleet.getFleetData().addFleetMember("sfccrius_Blaster");
        fleet.getFleetData().addFleetMember("sfccrius_Blaster");
        fleet.getFleetData().addFleetMember("sfccrius_Pressure");
        fleet.getFleetData().addFleetMember("sfcphaeton_ballistics");
        fleet.getFleetData().addFleetMember("sfcphaeton_ballistics");
        fleet.getFleetData().addFleetMember("sfcphaeton_ballistics");
        fleet.getFleetData().addFleetMember("sfcdrachm_Pressure");
        fleet.getFleetData().addFleetMember("sfcdrachm_Pressure");
        fleet.getFleetData().addFleetMember("sfcdrachm_Pressure");
        fleet.getFleetData().addFleetMember("sfcdrachm_Pressure");
        fleet.getFleetData().addFleetMember("sfcbia_Hunter");
        fleet.getFleetData().addFleetMember("sfcbia_Hunter");
        fleet.getFleetData().addFleetMember("sfcbia_Defender");
        fleet.getFleetData().addFleetMember("sfcbia_Defender");
        fleet.getFleetData().addFleetMember("sfcdram_assault");
        fleet.getFleetData().addFleetMember("sfcdram_assault");
        fleet.getFleetData().addFleetMember("sfcdram_assault");
        fleet.getFleetData().addFleetMember("sfcdram_missile");
        fleet.getFleetData().addFleetMember("sfcdram_missile"); //All to be added later
        fleet.getFleetData().addFleetMember("sfcdram_missile"); */
        fleet.getFleetData().addFleetMember("sfcslent_Offense");
        fleet.getFleetData().addFleetMember("sfcslent_Offense");
        fleet.getFleetData().addFleetMember("sfcslent_Offense");
        fleet.getFleetData().addFleetMember("sfcslent_Offense");
        fleet.getFleetData().addFleetMember("sfcslent_Defense");
        fleet.getFleetData().addFleetMember("sfcslent_Defense");
        fleet.getFleetData().addFleetMember("sfcslent_Defense");
        fleet.getFleetData().addFleetMember("sfcslent_Defense");
        fleet.getFleetData().addFleetMember("sfcpolus_Torpedo");
        fleet.getFleetData().addFleetMember("sfcpolus_Torpedo");
        fleet.getFleetData().addFleetMember("sfctalaria_Strike");
        fleet.getFleetData().addFleetMember("sfctalaria_Strike");
        fleet.setNoFactionInName(true);
        fleet.setName("The Grand Fuel Fleet");
        volturn.getContainingLocation().addEntity(fleet);
        fleet.setAI(Global.getFactory().createFleetAI(fleet));
        fleet.setMarket(volturn.getMarket());
        fleet.setLocation(volturn.getLocation().x, volturn.getLocation().y);
        fleet.setFacing((float) Math.random() * 360f);
        fleet.getAI().addAssignment(FleetAssignment.DEFEND_LOCATION, volturn, (float) Math.random() * 90000f, null);
    }
    private void addNFTMerchantMilitia() {
        SectorAPI sector = Global.getSector();
        StarSystemAPI system = sector.getStarSystem("Naraka");
        SectorEntityToken nachiketa = system.getEntityById("nachiketa");
        // SFC Grand Fuel Fleet
        FleetParamsV3 params = new FleetParamsV3(
                nachiketa.getMarket(), // add a source(has to be from a MarketAPI)
                null, // loc in hyper; don't need if have market
                "hegemony",
                1f, // quality override route.getQualityOverride()
                FleetTypes.TASK_FORCE,
                50f, // combatPts(minimal so special ships can be added)
                0f, // freighterPts
                0f, // tankerPts
                0f, // transportPts
                0f, // linerPts
                0f, // utilityPts
                0f// qualityMod
        );
        params.officerNumberMult = 1f;
        params.officerLevelBonus = 3;
        params.officerNumberBonus = 3;
        params.officerLevelLimit = Global.getSettings().getInt("officerMaxLevel") + (int) OfficerTraining.MAX_LEVEL_BONUS;
        params.modeOverride = FactionAPI.ShipPickMode.ALL;
        params.averageSMods = 1;
        params.flagshipVariantId = "eagle_xiv_Elite";
        CampaignFleetAPI fleet = FleetFactoryV3.createFleet(params);
        if (fleet == null || fleet.isEmpty()) return;
        fleet.setFaction("hegemony", true);
        fleet.getFlagship().setShipName("NMS Pyramid");
        fleet.getFlagship().setId("eagle_xiv_Elite");
        fleet.getFleetData().addFleetMember("condor_Support");
        fleet.getFleetData().addFleetMember("condor_Support");
        fleet.getFleetData().addFleetMember("hammerhead_Support");
        fleet.getFleetData().addFleetMember("hammerhead_Support");
        fleet.getFleetData().addFleetMember("hammerhead_Support");
        fleet.getFleetData().addFleetMember("enforcer_Balanced");
        fleet.getFleetData().addFleetMember("enforcer_Balanced");
        fleet.getFleetData().addFleetMember("enforcer_Balanced");
        fleet.getFleetData().addFleetMember("manticore_Support");
        fleet.getFleetData().addFleetMember("manticore_Support");
        fleet.getFleetData().addFleetMember("manticore_Support");
        fleet.getFleetData().addFleetMember("mule_Standard");
        fleet.getFleetData().addFleetMember("mule_Standard");
        fleet.getFleetData().addFleetMember("mule_Standard");
        fleet.getFleetData().addFleetMember("mule_Standard");
        fleet.getFleetData().addFleetMember("kite_hegemony_Interceptor");
        fleet.getFleetData().addFleetMember("kite_hegemony_Interceptor");
        fleet.getFleetData().addFleetMember("kite_hegemony_Interceptor");
        fleet.getFleetData().addFleetMember("kite_Support");
        fleet.getFleetData().addFleetMember("kite_Support");
        fleet.getFleetData().addFleetMember("kite_Support");
        fleet.setNoFactionInName(true);
        fleet.setName("NFT, Inc. Merchant Militia");
        nachiketa.getContainingLocation().addEntity(fleet);
        fleet.setAI(Global.getFactory().createFleetAI(fleet));
        fleet.setMarket(nachiketa.getMarket());
        fleet.setLocation(nachiketa.getLocation().x, nachiketa.getLocation().y);
        fleet.setFacing((float) Math.random() * 360f);
        fleet.getAI().addAssignment(FleetAssignment.DEFEND_LOCATION, nachiketa, (float) Math.random() * 90000f, null);
    }

    @Override
    public void onNewGameAfterEconomyLoad() {
        MarketAPI volturn = Global.getSector().getEconomy().getMarket("volturn");
        if (volturn != null) {
            addGrandFuelFleet();}
        MarketAPI nachiketa = Global.getSector().getEconomy().getMarket("nachiketa");
        if (nachiketa != null) {
            addNFTMerchantMilitia();}
            ImportantPeopleAPI ip = Global.getSector().getImportantPeople();
            SectorAPI sector = Global.getSector();
            StarSystemAPI system = sector.getStarSystem("Askonia");
            MarketAPI market = Global.getSector().getEconomy().getMarket("sindria");

            if (market != null) {

                SectorEntityToken cnc = Global.getSector().getEntityById("diktat_cnc");
                cnc.setCustomDescriptionId("station_sindria_sindrian_fuel");

                PersonAPI sfckweenPerson = Global.getFactory().createPerson();
                sfckweenPerson.setId(sfckween);
                sfckweenPerson.setFaction(Factions.DIKTAT);
                sfckweenPerson.setGender(Gender.FEMALE);
                sfckweenPerson.setRankId(Ranks.SPACE_ADMIRAL);
                sfckweenPerson.setPostId(Ranks.POST_SCIENTIST);
                sfckweenPerson.setImportance(PersonImportance.HIGH);
                sfckweenPerson.setVoice(Voices.SCIENTIST);
                sfckweenPerson.getName().setFirst("Yunris");
                sfckweenPerson.getName().setLast("Kween");
                sfckweenPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfckween"));
                sfckweenPerson.addTag(Tags.CONTACT_UNDERWORLD);
                market.getCommDirectory().addPerson(sfckweenPerson, 2);
                market.addPerson(sfckweenPerson);
                ip.addPerson(sfckweenPerson);

                PersonAPI sfcmannPerson = Global.getFactory().createPerson();
                sfcmannPerson.setId(sfcmann);
                sfcmannPerson.setFaction(Factions.DIKTAT);
                sfcmannPerson.setGender(Gender.MALE);
                sfcmannPerson.setRankId(Ranks.SPACE_ADMIRAL);
                sfcmannPerson.setPostId("sfcleaddeveloper");
                sfcmannPerson.setImportance(PersonImportance.HIGH);
                sfcmannPerson.setVoice(Voices.SCIENTIST);
                sfcmannPerson.getName().setFirst("Gregory");
                sfcmannPerson.getName().setLast("Mannfred");
                sfcmannPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcmann"));
                sfcmannPerson.addTag(Tags.CONTACT_TRADE);
                market.getCommDirectory().addPerson(sfcmannPerson, 3);
                market.addPerson(sfcmannPerson);
                ip.addPerson(sfcmannPerson);

                PersonAPI sfcruniPerson = Global.getFactory().createPerson();
                sfcruniPerson.setId(sfcruni);
                sfcruniPerson.setFaction(Factions.DIKTAT);
                sfcruniPerson.setGender(Gender.FEMALE);
                sfcruniPerson.setRankId(Ranks.SPACE_CAPTAIN);
                sfcruniPerson.setPostId(Ranks.POST_OFFICER);
                sfcruniPerson.setImportance(PersonImportance.VERY_LOW);
                sfcruniPerson.setVoice(Voices.SOLDIER);
                sfcruniPerson.getName().setFirst("Yunifer");
                sfcruniPerson.getName().setLast("Runi");
                sfcruniPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcruni"));
                sfcruniPerson.getStats().setSkillLevel(Skills.COMBAT_ENDURANCE, 2);
                sfcruniPerson.getStats().setSkillLevel(Skills.POINT_DEFENSE, 2);
                sfcruniPerson.getStats().setSkillLevel(Skills.MISSILE_SPECIALIZATION, 2);
                sfcruniPerson.getStats().setSkillLevel(Skills.TARGET_ANALYSIS, 2);
                sfcruniPerson.getStats().setSkillLevel(Skills.HELMSMANSHIP, 1);
                sfcruniPerson.getStats().setSkillLevel(Skills.DAMAGE_CONTROL, 1);
                sfcruniPerson.getStats().setSkillLevel(Skills.ENERGY_WEAPON_MASTERY, 1);
                sfcruniPerson.getStats().setLevel(7);

                market.getCommDirectory().addPerson(sfcruniPerson);
                market.addPerson(sfcruniPerson);
                market.getCommDirectory().getEntryForPerson(sfcruniPerson).setHidden(true);
                ip.addPerson(sfcruniPerson);
            }

                market = Global.getSector().getEconomy().getMarket("cruor");
                if (market != null) {

                    SectorEntityToken a3 = system.getEntityById("cruor");
                    a3.getMarket().addIndustry(Industries.PATROLHQ);

                    PersonAPI sfcdunnPerson = Global.getFactory().createPerson();
                    sfcdunnPerson.setId(sfcdunn);
                    sfcdunnPerson.setFaction(Factions.DIKTAT);
                    sfcdunnPerson.setGender(Gender.MALE);
                    sfcdunnPerson.setRankId(Ranks.SPACE_ADMIRAL);
                    sfcdunnPerson.setPostId("sfclaborchief");
                    sfcdunnPerson.setImportance(PersonImportance.HIGH);
                    sfcdunnPerson.getName().setFirst("Meridin");
                    sfcdunnPerson.getName().setLast("Dunn");
                    sfcdunnPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcdunn"));
                    sfcdunnPerson.addTag(Tags.CONTACT_TRADE);
                    sfcdunnPerson.setVoice(Voices.SPACER);
                    sfcdunnPerson.getStats().setSkillLevel(Skills.INDUSTRIAL_PLANNING, 1);
                    market.setAdmin(sfcdunnPerson);
                    market.getCommDirectory().addPerson(sfcdunnPerson, 0);
                    market.addPerson(sfcdunnPerson);
                    ip.addPerson(sfcdunnPerson);

                    PersonAPI sfcruyPerson = Global.getFactory().createPerson();
                    sfcruyPerson.setId(sfcruy);
                    sfcruyPerson.setFaction(Factions.DIKTAT);
                    sfcruyPerson.setGender(Gender.MALE);
                    sfcruyPerson.setRankId(Ranks.SPACE_ADMIRAL);
                    sfcruyPerson.setPostId("sfcsecchief");
                    sfcruyPerson.setImportance(PersonImportance.MEDIUM);
                    sfcruyPerson.getName().setFirst("Rudric");
                    sfcruyPerson.getName().setLast("Ruy");
                    sfcruyPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcruy"));
                    sfcruyPerson.addTag(Tags.CONTACT_MILITARY);
                    sfcruyPerson.setVoice(Voices.SOLDIER);
                    market.getCommDirectory().addPerson(sfcruyPerson,1);
                    market.addPerson(sfcruyPerson);
                    ip.addPerson(sfcruyPerson);

                }

                market = Global.getSector().getEconomy().getMarket("volturn");
                if (market != null) {

                    PersonAPI sfcfleuresPerson = Global.getFactory().createPerson();
                    sfcfleuresPerson.setId(sfcfleures);
                    sfcfleuresPerson.setFaction(Factions.DIKTAT);
                    sfcfleuresPerson.setGender(Gender.FEMALE);
                    sfcfleuresPerson.setRankId(Ranks.SPACE_ADMIRAL);
                    sfcfleuresPerson.setPostId("sfcadvertchief");
                    sfcfleuresPerson.setImportance(PersonImportance.HIGH);
                    sfcfleuresPerson.getName().setFirst("Lumi");
                    sfcfleuresPerson.getName().setLast("Fleures");
                    sfcfleuresPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "sfcfleures"));
                    sfcfleuresPerson.addTag(Tags.CONTACT_TRADE);
                    sfcfleuresPerson.setVoice(Voices.OFFICIAL);
                    market.setAdmin(sfcfleuresPerson);
                    market.getCommDirectory().addPerson(sfcfleuresPerson, 0);
                    market.addPerson(sfcfleuresPerson);
                    ip.addPerson(sfcfleuresPerson);
                }
                // DE reference
            market = Global.getSector().getEconomy().getMarket("ryzan_supercomplex");
            if (market != null) {

                PersonAPI dedustierPerson = Global.getFactory().createPerson();
                dedustierPerson.setId(dedustier);
                dedustierPerson.setFaction(Factions.LIONS_GUARD);
                dedustierPerson.setGender(Gender.MALE);
                dedustierPerson.setRankId("sfcexecutive");
                dedustierPerson.setPostId("sfcregmanager");
                dedustierPerson.setImportance(PersonImportance.VERY_HIGH);
                dedustierPerson.getName().setFirst("Randall");
                dedustierPerson.getName().setLast("Bex-Dustier");
                dedustierPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "dedustier"));
                dedustierPerson.getStats().setSkillLevel(Skills.INDUSTRIAL_PLANNING, 1);
                dedustierPerson.getStats().setSkillLevel(Skills.TACTICAL_DRILLS, 1);
                market.setAdmin(dedustierPerson);
                market.getCommDirectory().addPerson(dedustierPerson, 0);
                market.addPerson(dedustierPerson);
                ip.addPerson(dedustierPerson);
            }

                //the nft starts here
                market = Global.getSector().getEconomy().getMarket("nachiketa");
                if (market != null) {
                    PersonAPI nftpononziPerson = Global.getFactory().createPerson();
                    nftpononziPerson.setId(nftpononzi);
                    nftpononziPerson.setFaction(Factions.HEGEMONY);
                    nftpononziPerson.setGender(Gender.MALE);
                    nftpononziPerson.setRankId("nftexecutive");
                    nftpononziPerson.setPostId("nftexecutive");
                    nftpononziPerson.setImportance(PersonImportance.VERY_HIGH);
                    nftpononziPerson.getName().setFirst("Karlos");
                    nftpononziPerson.getName().setLast("Pononzi");
                    nftpononziPerson.setPortraitSprite(Global.getSettings().getSpriteName("characters", "nftpononzi"));
                    nftpononziPerson.addTag(Tags.CONTACT_TRADE);
                    nftpononziPerson.setVoice(Voices.BUSINESS);
                    market.getCommDirectory().addPerson(nftpononziPerson, 1);
                    market.getCommDirectory().getEntryForPerson(nftpononziPerson).setHidden(false);
                    market.addPerson(nftpononziPerson);
                    ip.addPerson(nftpononziPerson);
                }

            PersonAPI sec_officer = Global.getSector().getImportantPeople().getPerson("sec_officer");
            if (sec_officer != null) {
                sec_officer.setRankId("sfcjunior");
                sec_officer.setPostId("sfcjunior");
                sec_officer.addTag(Tags.CONTACT_MILITARY);
            }
    }
}